grammar Language2_infix;







expression : exp EOF
           ;

exp : term ( '+' term | '-' term )*
    ;

term : signed ( '*' signed | '/' signed | '%' signed )*
     ;

signed :  '-'?  factor
       ;

factor : base ( '^' signed )?
       ;

base : '(' exp ')'
     | INTEGER
     ;

INTEGER : '0'..'9'+
        ;

WS : (' '|'\t'|'\n'|'\r')+ {skip();}
   ;
