/*
   This program parses and then evaluates strings from Language-5.
*/

public class Examples
{
   public static void main(String[] args)
   {
     // Compare the evaluation of this expression
     // in this language and in Language-4.
      String expr1 = "( begin " +
                       "( begin ( var x 2 ) " +
                               "( var y 2 ) ) " +
                       "( var z ( + x y ) ) " +
                     ")";

      String expr2 = "( begin " +
                       "( var x 4 ) " +
                       "( begin ( var y false ) " +
                               "( || y ( == ( + 2 x ) ( * 2 3 ) ) ) ) )";

      String expr3 = "( begin " +
                         "( var x ( begin ( var z 2 ) ( + z z ) ) ) " +
                         "( begin ( var y false ) " +
                                 "( begin ( var u 2 ) " +
                                         "( begin " +
                                            "( var v ( || y ( == ( + u 4 ) ( * u 3 ) ) ) ) " +
                                            "v ) ) ) )";

      String expr4 = "( var x " +
                       "( begin ( var y 2 ) " +
                               "( var z ( + y 3 ) ) ) ) ";

      String expr = expr2;

      // build the abstract syntax tree that represents the expression
      BTree ast = BuildBTree.buildBTree( expr );

      // print the original expression
      System.out.println( expr + "\n" );
       // pretty-print the abstract syntax tree
      System.out.println( PrettyPrinter3.prettyPrint( ast ) + "\n" );
      // print the infix version of the expression
      System.out.println( AST2infix.ast2infix( ast ) + "\n" );

      // evaluate the expression (interpret the AST)
      Value value = Evaluate.evaluate( ast );

      System.out.println( "result = " + value );
   }//main

}//Examples
