grammar Language2_AST;

options
{
   output=AST;
   ASTLabelType=CommonTree;
}

expression : exp EOF
           ;

exp : '(' binOp exp exp ')' -> ^( binOp exp exp )
    | INTEGER
    ;

binOp : '+' | '-' | '*' | '/' | '%' | '^'
      ;

INTEGER : '0'..'9'+
        ;

WS : (' '|'\t'|'\n'|'\r')+ {skip();}
   ;
