grammar UnaryMinus_AST;

options
{
   output=AST;
   ASTLabelType=CommonTree;
}

tokens { NEG; }

expression : exp EOF ;

exp : num ( '-'^ num )* ;                 // subtraction

num : '-' INTEGER -> ^(NEG INTEGER)       // negation
    |     INTEGER
    ;

INTEGER : '0'..'9'+ ;

WS : (' '|'\t'|'\n'|'\r')+ {skip();} ;


/* Why doesn't this work?
num : '-'? INTEGER -> (^(NEG INTEGER))? ; // negation or not
*/
