tree grammar UnaryMinus_AST_eval;

options
{
   tokenVocab=UnaryMinus_AST;
   ASTLabelType=CommonTree;
}

expression returns [int result] : exp EOF {$result=$exp.result;} ;

exp returns [int result]
    : ^('-' a=exp b=exp) {$result = a-b;}  /* subtraction */
    | ^(NEG a=exp)       {$result = -a;}   /* negation */
    | INTEGER            {$result =  Integer.parseInt($INTEGER.text);}
    ;


