grammar Language1_DFS_inorder; /* This is only defined for binary trees */

stree : tr EOF {System.out.println("DFS, in-order = "+$tr.result);}
      ;

tr returns [String result]
   : '(' ID a=tr b=tr? ')' {$result=$a.result+$ID.text+(($b.result!=null)?$b.result:"");}
   | ID {$result=$ID.text;}
   ;


ID : ('a'..'z'|'A'..'Z')+
   ;

WS : (' '|'\t'|'\n'|'\r')+ {skip();}
   ;

/*
tr returns [String result]
   : '(' ID a=tr {$result=$a.result+$ID.text;} (b=tr {$result+=$b.result;})? ')'
   | ID {$result=$ID.text;}
   ;
*/




/*
stree : {System.out.println("DFS, in-order = ";} tr EOF {System.out.println();}
      ;

tr
   : '(' ID tr {System.out.println($ID.text+" ");} tr ')'
   | ID {System.out.print($ID.text+" ");}
   ;
*/