grammar Language1_DFS_preorder;

stree : tr EOF {System.out.println("DFS, pre-order = "+$tr.result);}
      ;

tr returns [String result]
   : '(' ID {$result=$ID.text;} (a=tr {$result+=$a.result;})+ ')'
   | ID {$result=$ID.text;}
   ;


ID : ('a'..'z'|'A'..'Z')+
   ;

WS : (' '|'\t'|'\n'|'\r')+ {skip();}
   ;

/*
stree : {System.out.println("DFS, pre-order = ";} tr EOF {System.out.println();}
      ;

tr
   : '(' ID {System.out.println($ID.text+" ");} tr+ ')'
   | ID {System.out.print($ID.text+" ");}
   ;
*/
