grammar Language1_count_nodes;

stree : tr EOF {System.out.println("node count = "+$tr.result);}
      ;

tr returns [int result]
   : '(' ID a=tr {$result=1+$a.result;}
           (b=tr {$result+= $b.result;})* ')'
   | ID {$result=1;}
   ;

ID : ('a'..'z'|'A'..'Z')+
   ;

WS : (' '|'\t'|'\n'|'\r')+ {skip();}
   ;
