grammar Language1_depth;

stree : tr EOF {System.out.println("tree depth = "+$tr.result);}
      ;

tr returns [int result]
   : '(' ID a=tr  {$result=$a.result;}
            b=tr* {$result=Math.max($result,$b.result);} ')' {$result=1+$result;}
   | ID {$result=0;}
   ;

ID : ('a'..'z'|'A'..'Z')+
   ;

WS : (' '|'\t'|'\n'|'\r')+ {skip();}
   ;
