grammar Language1_max_degree;

stree : tr EOF {System.out.println("maximum degree = "+$tr.result);}
      ;

tr returns [int result]
@init {int counter=0;}
   : '(' ID a=tr {counter++; $result=$a.result;}
           (b=tr {counter++; $result=Math.max($result,$b.result);})* ')'
      {$result=Math.max(result, counter);}
   | ID {$result=0;}
   ;

ID : ('a'..'z'|'A'..'Z')+
   ;

WS : (' '|'\t'|'\n'|'\r')+ {skip();}
   ;
