grammar Language1_AST;

options
{
   output=AST;
   ASTLabelType=CommonTree;
}

stree : tr EOF {System.out.println($tr.tree.toStringTree());}
      ;

tr : '(' ID tr+ ')' -> ^( ID tr+ )
   | ID             -> ID
   ;

ID : ('a'..'z'|'A'..'Z')+
   ;

WS : (' '|'\t'|'\n'|'\r')+ {skip();}
   ;
