tree grammar Language1_AST_DFS_postorder;

options
{
   tokenVocab=Language1_AST;
   ASTLabelType=CommonTree;
}

stree : tr EOF {System.out.println("DFS, post-order = "+$tr.result);}
      ;

tr returns [String result]
   : ^( ID a=tr {$result=$a.result;} (b=tr {$result+=$b.result;})* ) {$result+=$ID.text;}
   | ID {$result=$ID.text;}
   ;

/*
// this doesn't work correctly?
tr returns [String result]
   : ^( ID (a=tr {$result+=$a.result;})+ ) {$result+=$ID.text;}
   | ID {$result=$ID.text;}
   ;
*/

/*
stree : {System.out.println("DFS, post-order = ";} tr EOF {System.out.println();}
      ;

tr
   : ^( ID tr+ ) {System.out.println($ID.text+" ");}
   | ID {System.out.print($ID.text+" ");}
   ;
*/
