tree grammar Language1_AST_depth;

options
{
   tokenVocab=Language1_AST;
   ASTLabelType=CommonTree;
}

stree : tr EOF {System.out.println("tree depth = "+$tr.result);}
      ;

tr returns [int result]
   : ^( ID a=tr  {$result=$a.result;}
           b=tr* {$result=Math.max($result,$b.result);} ) {$result=1+$result;}
   | ID {$result=0;}
   ;
