tree grammar UnaryMinus_AST_ver2_eval;

options
{
   tokenVocab=UnaryMinus_AST_ver2;
   ASTLabelType=CommonTree;
}

expression returns [int result] : exp EOF {$result=$exp.result;} ;

exp returns [int result]
    : ^('-' a=exp ( b=exp {$result=a-b;}  // subtraction
                  |       {$result=-a;}   // negation
                  ) )
    | INTEGER     {$result=Integer.parseInt($INTEGER.text);}
    ;


/* Why can't we do something like this?
exp returns [int result]
    : ^('-' a=exp (b=exp)?) {$result=( what goes here? )?a-b:-a;} // subtraction or negation
    | INTEGER     {$result=Integer.parseInt($INTEGER.text);}
    ;
*/
