grammar UnaryMinus_eval;







expression returns [int result] : exp EOF {$result=$exp.result;} ;

exp returns [int result] : a=num {$result = $a.result;} ( '-' b=num {$result -= $b.result;} )* ;

num returns [int result] : '-' INTEGER {$result = -Integer.parseInt($INTEGER.text);}
                         |     INTEGER {$result =  Integer.parseInt($INTEGER.text);}
                         ;

INTEGER : '0'..'9'+ ;

WS : (' '|'\t'|'\n'|'\r')+ {skip();} ;


