tree grammar Language1_AST_DFS_inorder; /* This is only defined for binary trees */

options
{
   tokenVocab=Language1_AST;
   ASTLabelType=CommonTree;
}

stree : tr EOF {System.out.println("DFS, in-order = "+$tr.result);}
      ;

tr returns [String result]
   : ^( ID a=tr b=tr? ) {$result=$a.result+$ID.text+(($b.result!=null)?$b.result:"");}
   | ID {$result=$ID.text;}
   ;


/*
tr returns [String result]
   : ^( ID a=tr {$result=$a.result+$ID.text;} (b=tr {$result+=$b.result;})? )
   | ID {$result=$ID.text;}
   ;
*/




/*
stree : {System.out.println("DFS, in-order = ";} tr EOF {System.out.println();}
      ;

tr
   : ^( ID tr {System.out.println($ID.text+" ");} tr )
   | ID {System.out.print($ID.text+" ");}
   ;
*/
