tree grammar Language1_AST_count_root;

options
{
   tokenVocab=Language1_AST;
   ASTLabelType=CommonTree;
}

stree : tr EOF {System.out.println("root node count = "+$tr.result);}
      ;

tr returns [int result]
   : ^( ID a=subtree[$ID.text]  {$result=1+$a.result;}
           b=subtree[$ID.text]* {$result+=$b.result;} )
   | ID {$result=1;}
   ;

subtree[String rootText] returns [int result]
   : ^( ID a=subtree[$rootText]  {$result=($rootText.equals($ID.text)?1:0)+$a.result;}
           b=subtree[$rootText]* {$result+=$b.result;} )
   | ID {$result=$rootText.equals($ID.text)?1:0;}
   ;

