/*
  In C, declarations are not allowed in the
  clauses of an if-statement unless those
  clauses are contained in a pair of braces,
  which create a new scope (environment).
*/

int main()
{
   if ( 0 )
   {  int x = 1; }
   else
   {  double x = 1.0; }

   // A statement like this, if it were allowed, would
   // make it impossible to type check a language.
   if ( 0 )
      int x = 1;
   else
      double x = 1.0;
}
